﻿// ALL Y'ALL v0.2
// By 5thHorseman
// License: CC SA
// v0.1: Added "Extend All" and "Retract All" to deployable solar panels.
// v0.2: Added "Extend All" and "Retract All" to deployable radiators.
// v0.3: (proposed) Add "Perform All Science" to all science instruments.
// v0.9: (proposed) Modify UI to lessen the number of lines in right-click menus.
// Future possibilities: Add buttons to Command Modules as well, perhaps in a config option/setting.

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UnityEngine;

namespace AllYAll
{

    // ############# SOLAR PANELS ############### //

    public class AYA_Solar : PartModule
    {
        [KSPEvent(guiActive = true, guiActiveEditor = false, guiName = "Extend All")]
        public void ExtendAllSolar()
        {
            foreach (Part eachPart in vessel.Parts)
            {
                var panel = eachPart.FindModuleImplementing<ModuleDeployableSolarPanel>();
                if (panel != null) panel.Extend();
            }
        }
        [KSPEvent(guiActive = true, guiActiveEditor = false, guiName = "Retract All")]
        public void RetractAllSolar()
        {
            foreach (Part eachPart in vessel.Parts)
            {
                var panel = eachPart.FindModuleImplementing<ModuleDeployableSolarPanel>();
                if (panel != null) panel.Retract();
            }
        }
    }

    // ############# RADIATORS ############### //

    public class AYA_Radiator : PartModule
    {
        [KSPEvent(guiActive = true, guiActiveEditor = false, guiName = "Extend All")]
        public void ExtendAllRadiator()
        {
            foreach (Part eachPart in vessel.Parts)
            {
                var panel = eachPart.FindModuleImplementing<ModuleDeployableRadiator>();
                if (panel != null) panel.Extend();
            }
        }
        [KSPEvent(guiActive = true, guiActiveEditor = false, guiName = "Retract All")]
        public void RetractAllRadiator()
        {
            foreach (Part eachPart in vessel.Parts)
            {
                var panel = eachPart.FindModuleImplementing<ModuleDeployableRadiator>();
                if (panel != null) panel.Retract();
            }
        }
    }

    // ############# SCIENCE ############### //

    public class AYA_Science : PartModule
    {
        [KSPEvent(guiActive = true, guiActiveEditor = false, guiName = "Perform All Science")]
        public void DoAllScience()
        {
            foreach (Part eachPart in vessel.Parts)
            {
                var scipanel = eachPart.FindModuleImplementing<ModuleScienceExperiment>();
                if (scipanel != null) scipanel.DeployExperiment();
            }
        }
    }

}
